import { IOptions, Field, IField } from 'wind-core';
export { Field } from 'wind-core';

interface IWindOptions extends IOptions {
    opacity: number;
    zIndex: number;
    context: '2d';
    windOptions: Partial<IOptions>;
    [key: string]: any;
}
declare const BMap: any;
declare class BMapWind extends BMap.Overlay {
    private options;
    private canvas;
    private wind;
    private context;
    private field;
    private map;
    private paneName;
    private zIndex;
    private mixBlendMode;
    enableMassClear: boolean;
    constructor(data: any, options?: Partial<IWindOptions>);
    /**
     * append layer to map
     * @param map
     */
    appendTo(map: any): void;
    initialize(map: any): HTMLCanvasElement;
    private handleResize;
    bindEvent(): void;
    unbindEvent(): void;
    start(): void;
    stop(): void;
    private adjustSize;
    draw(): void;
    private _draw;
    /**
     * render windy layer
     * @param canvas
     * @returns {BMapWind}
     */
    render(canvas: HTMLCanvasElement): this;
    /**
     * get canvas context
     * @returns {*}
     */
    private getContext;
    getContainer(): HTMLCanvasElement | null;
    private getProjection;
    transferToMercator(coordinates: [number, number]): [number, number];
    private projectInner;
    project(coordinate: [number, number]): [number, number];
    unproject(pixel: [number, number]): [number, number];
    intersectsCoordinate(coordinate: [number, number]): boolean;
    private pickWindOptions;
    /**
     * get wind layer data
     */
    getData(): Field | undefined;
    /**
     * set layer data
     * @param data
     * @param options
     * @returns {BMapWind}
     */
    setData(data: any, options?: Partial<IField>): this;
    updateParams(options?: Partial<IOptions>): this;
    getParams(): Partial<IOptions>;
    setWindOptions(options: Partial<IOptions>): void;
    getWindOptions(): Partial<IOptions>;
    show(): void;
    hide(): void;
    setZIndex(zIndex: number): void;
    getZIndex(): number;
}
declare const WindLayer: typeof BMapWind;

export { type IWindOptions, WindLayer, BMapWind as default };
